# NetworkInterfacesApi

## NetworkInterfacesApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                                                               | HTTP request                                                           | Description           |
| ------------------------------------------------------------------------------------ | ---------------------------------------------------------------------- | --------------------- |
| [**datacenters\_servers\_nics\_delete**](#datacenters_servers_nics_delete)           | **DELETE** /datacenters/{datacenterId}/servers/{serverId}/nics/{nicId} | Delete NICs           |
| [**datacenters\_servers\_nics\_find\_by\_id**](#datacenters_servers_nics_find_by_id) | **GET** /datacenters/{datacenterId}/servers/{serverId}/nics/{nicId}    | Retrieve NICs         |
| [**datacenters\_servers\_nics\_get**](#datacenters_servers_nics_get)                 | **GET** /datacenters/{datacenterId}/servers/{serverId}/nics            | List NICs             |
| [**datacenters\_servers\_nics\_patch**](#datacenters_servers_nics_patch)             | **PATCH** /datacenters/{datacenterId}/servers/{serverId}/nics/{nicId}  | Partially modify NICs |
| [**datacenters\_servers\_nics\_post**](#datacenters_servers_nics_post)               | **POST** /datacenters/{datacenterId}/servers/{serverId}/nics           | Create a NIC          |
| [**datacenters\_servers\_nics\_put**](#datacenters_servers_nics_put)                 | **PUT** /datacenters/{datacenterId}/servers/{serverId}/nics/{nicId}    | Modify NICs           |

## **datacenters\_servers\_nics\_delete**

> datacenters\_servers\_nics\_delete(datacenter\_id, server\_id, nic\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Delete NICs

Remove the specified NIC.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    nic_id = 'nic_id_example' # str | The unique ID of the NIC.
    try:
        # Delete NICs
        api_instance.datacenters_servers_nics_delete(datacenter_id, server_id, nic_id)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_delete: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**  | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **nic\_id**             | **str**  | The unique ID of the NIC.                                                                                                                                                                                                                                                                                                                                                                                                                |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

void (empty response body)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_servers\_nics\_find\_by\_id**

> Nic datacenters\_servers\_nics\_find\_by\_id(datacenter\_id, server\_id, nic\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Retrieve NICs

Retrieve the properties of the specified NIC.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    nic_id = 'nic_id_example' # str | The unique ID of the NIC.
    try:
        # Retrieve NICs
        api_response = api_instance.datacenters_servers_nics_find_by_id(datacenter_id, server_id, nic_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_find_by_id: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**  | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **nic\_id**             | **str**  | The unique ID of the NIC.                                                                                                                                                                                                                                                                                                                                                                                                                |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Nic**](/python-sdk/models/nic.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_servers\_nics\_get**

> Nics datacenters\_servers\_nics\_get(datacenter\_id, server\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number, offset=offset, limit=limit)

List NICs

List all NICs, attached to the specified server.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    try:
        # List NICs
        api_response = api_instance.datacenters_servers_nics_get(datacenter_id, server_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_get: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**  | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |
| **offset**              | **int**  | The first element (from the complete list of the elements) to include in the response (used together with \<b>\<i>limit\</i>\</b> for pagination).                                                                                                                                                                                                                                                                                       | \[optional] \[default to 0]    |
| **limit**               | **int**  | The maximum number of elements to return (use together with offset for pagination).                                                                                                                                                                                                                                                                                                                                                      | \[optional] \[default to 1000] |

#### Return type

[**Nics**](/python-sdk/models/nics.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **datacenters\_servers\_nics\_patch**

> Nic datacenters\_servers\_nics\_patch(datacenter\_id, server\_id, nic\_id, nic, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Partially modify NICs

Update the properties of the specified NIC.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    nic_id = 'nic_id_example' # str | The unique ID of the NIC.
    nic = ionoscloud.NicProperties() # NicProperties | The properties of the NIC to be updated.
    try:
        # Partially modify NICs
        api_response = api_instance.datacenters_servers_nics_patch(datacenter_id, server_id, nic_id, nic)
        print(api_response)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_patch: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**                                                  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**                                                  | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **nic\_id**             | **str**                                                  | The unique ID of the NIC.                                                                                                                                                                                                                                                                                                                                                                                                                |                                |
| **nic**                 | [**NicProperties**](/python-sdk/models/nicproperties.md) | The properties of the NIC to be updated.                                                                                                                                                                                                                                                                                                                                                                                                 |                                |
| **pretty**              | **bool**                                                 | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Nic**](/python-sdk/models/nic.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **datacenters\_servers\_nics\_post**

> Nic datacenters\_servers\_nics\_post(datacenter\_id, server\_id, nic, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Create a NIC

Adds a NIC to the specified server. The combined total of NICs and attached volumes cannot exceed 24 per server.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    nic = ionoscloud.Nic() # Nic | The NIC to create.
    try:
        # Create a NIC
        api_response = api_instance.datacenters_servers_nics_post(datacenter_id, server_id, nic)
        print(api_response)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_post: %s\n' % e)
```

#### Parameters

| Name                    | Type                                 | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | ------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**                              | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**                              | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **nic**                 | [**Nic**](/python-sdk/models/nic.md) | The NIC to create.                                                                                                                                                                                                                                                                                                                                                                                                                       |                                |
| **pretty**              | **bool**                             | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                              | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                              | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Nic**](/python-sdk/models/nic.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **datacenters\_servers\_nics\_put**

> Nic datacenters\_servers\_nics\_put(datacenter\_id, server\_id, nic\_id, nic, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Modify NICs

Modify the properties of the specified NIC.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.NetworkInterfacesApi(api_client)
    datacenter_id = 'datacenter_id_example' # str | The unique ID of the data center.
    server_id = 'server_id_example' # str | The unique ID of the server.
    nic_id = 'nic_id_example' # str | The unique ID of the NIC.
    nic = ionoscloud.NicPut() # NicPut | The modified NIC
    try:
        # Modify NICs
        api_response = api_instance.datacenters_servers_nics_put(datacenter_id, server_id, nic_id, nic)
        print(api_response)
    except ApiException as e:
        print('Exception when calling NetworkInterfacesApi.datacenters_servers_nics_put: %s\n' % e)
```

#### Parameters

| Name                    | Type                                       | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | ------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **datacenter\_id**      | **str**                                    | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                                |
| **server\_id**          | **str**                                    | The unique ID of the server.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **nic\_id**             | **str**                                    | The unique ID of the NIC.                                                                                                                                                                                                                                                                                                                                                                                                                |                                |
| **nic**                 | [**NicPut**](/python-sdk/models/nicput.md) | The modified NIC                                                                                                                                                                                                                                                                                                                                                                                                                         |                                |
| **pretty**              | **bool**                                   | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                    | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                    | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**Nic**](/python-sdk/models/nic.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/python-sdk/api/networkinterfacesapi.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
